/* 
 *  GPS Interface
 *  Alberto García Hierro <skyhusker@rm-fr.net>
 */

#include <gps.h>
#include "gpsctl.h"

#define SERVER "localhost"
#define PORT "2947"

struct gps_data_t *gps_conn = NULL;

int
gps_initialize (void)
{
	gps_conn = gps_open (SERVER, PORT);

	if(gps_conn)
	{
		return 1;
	}

	return 0;
}

int
gps_get_xy (float *lat, float *lon)
{
	if(!gps_conn)
		return 0;
	
	*lat = (float) gps_conn->newdata.latitude;
	*lon = (float) gps_conn->newdata.longitude;
	return 1;
}

void
update_gpsdata ()
{
	if(!gps_conn)
		return;

	gps_query (gps_conn, "p");
}
