/*
 *  Prismstumbler external tool interface.
 *  (c) 2005 Florian Boor <florian@kernelconcepts.de>
 *
 *  This program is free software; you can redistribute it and/or modify
 *  it under the terms of the GNU General Public License as published by
 *  the Free Software Foundation; either version 2 of the License, or
 *  (at your option) any later version.
 *
 *  This program is distributed in the hope that it will be useful,
 *  but WITHOUT ANY WARRANTY; without even the implied warranty of
 *  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 *  GNU Library General Public License for more details.
 *
 *  You should have received a copy of the GNU General Public License
 *  along with this program; if not, write to the Free Software
 *  Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA 02111-1307, USA.
 */
#include <unistd.h>
#include <stdlib.h>
#include <stdio.h>
#include <string.h>
#include <sys/poll.h>
#include <glib.h>

#define WEPLAB_COMMAND PREFIX "/bin/weplab"

static FILE *extpipe = NULL;

gboolean
external_run_weplab(char *filename, char *params)
{
	char *command;
	
	command = g_strdup_printf(WEPLAB_COMMAND " %s %s 2>&1", params, filename);
	extpipe = popen(command, "r");
	g_free(command);
	
	return extpipe ? TRUE : FALSE;
}

gchar *
external_poll_output(void)
{
	static char str[256];
	struct pollfd pfd[1];
	gchar *result = NULL;
	int pr;
	
	if (!extpipe)
		return NULL;
	
	memset(str, 0, 256);
	pfd[0].fd = fileno(extpipe);
	pfd[0].events = (POLLIN | POLLRDNORM | POLLRDBAND | POLLPRI);
	while ((pr = poll(pfd, 1, 5)) > 0)
	{
		while (fgets (str, 255, extpipe))
		{
			gchar *tmp;
			if (result) 
			{
				tmp = g_strdup_printf("%s%s", result, str);
				g_free(result);
				result = tmp;
			}
			else
				result = g_strdup(str);
			
		}
	if ((pfd[0].revents & (POLLERR | POLLHUP | POLLNVAL)))
		break;
	}
	
	if ((pr < 0) || (pfd[0].revents & (POLLERR | POLLHUP | POLLNVAL)))
	{
		pclose(extpipe);
		extpipe = NULL;
	}
	return result;
}
